freeslot('mt_eggrobodummy','mt_eggrobocharge','mt_eggroboshot','s_eggroboshot','spr_egrl',
'mt_eggrobogiblet','s_eggrobogiblet1','s_eggrobogiblet2','s_eggrobogiblet3','s_eggrobogiblet4','s_eggrobogiblet5','spr_egrd')

local function IsTagEggRobo(player)
	if CBW_Battle and player.pflags&PF_TAGIT then return true
	else return false end
end

local function PlayerCanBeDamaged(player)
	if not(player.playerstate == PST_LIVE) then return false end
	if player.powers[pw_invulnerability] then return false end
	if player.powers[pw_super] then return false end
	if player.powers[pw_flashing] then return false end
	return true
end

local function MyTeam(player,myplayer)
	//Check yourself before you wreck yourself
	if myplayer == player then return true end
	//SP/coop checks
	if G_PlatformGametype() return true end
	//CTF checks
	if G_GametypeHasTeams() then
		if player.ctfteam == myplayer.ctfteam then return true
		else return false
		end
	end
	//Tag checks
	if G_TagGametype() then
		if player.pflags&PF_TAGIT == myplayer.pflags&PF_TAGIT then return true
		else return false
		end
	end
	return false
end

local function GetNearestPlayer(mo,fov,teamcheck,aim,ignorepain)
	if not(mo.player) and not (teamcheck == nil or teamcheck == 0) then return nil end //Teamchecks aren't allowed on nonplayer objects
	local nearest
	local neardist
	//Cycle through players
	for player in players.iterate
		//Failchecks
		if not (player.mo and player.playerstate == PST_LIVE) then continue end //Invalid player object
		if player.mo == mo then continue end // Don't count ourselves!
		if (teamcheck == 1 and not(MyTeam(player,mo.player))) //Need teammate
			or (teamcheck == -1 and MyTeam(player,mo.player)) //Need opponent
			or not(P_CheckSight(player.mo,mo)) //Not in view
			or player.mo.flags&MF_NOCLIPTHING //Can't target!
			then continue
		end
		if ignorepain == true and not(PlayerCanBeDamaged(player)) then continue end //Ignore invulnerable players
		if fov != nil then
			if aim == nil then aim = mo.angle end
			//Get angle
			local ang = R_PointToAngle2(mo.x,mo.y,player.mo.x,player.mo.y)-aim
			if ang > 180*ANG1 then ang = $-360*ANG1
			elseif ang < -180*ANG1 then ang = $+360*ANG1
			end
			//Check field of view
			if (ang < -fov/2*ANG1 or ang > fov/2*ANG1) then continue end
		end
		//Get distance
		local dist = R_PointToDist2(player.mo.x,player.mo.y,mo.x,mo.y)
		if nearest == nil or neardist > dist then
			nearest = player
			neardist = dist
		end
	end
	return nearest
end

local function GetZAngle(x1,y1,z1,x2,y2,z2)
	local xydist = R_PointToDist2(x1,y1,x2,y2)
	local zdist = z2-z1
	return R_PointToAngle2(0,0,xydist,zdist)
end

local function InstaThrustZAim(mo,xyangle,zangle,speed)
	local xythrust = P_ReturnThrustX(nil,zangle,speed)
	local zthrust = P_ReturnThrustY(nil,zangle,speed)
	P_InstaThrust(mo,xyangle,xythrust)		
	mo.momz = $+zthrust	
end

local function SearchObject(mo,aim,fov,range,searchflags,refmo,teamcheck)
		if refmo == nil then refmo = mo end
		local team
		if not(teamcheck == nil or teamcheck == 0) then
			if (mo.player) then
				team = mo.player.ctfteam
			else
				team = mo.ctfteam
			end
			if team == nil or team == 0 then
				team = 0
				teamcheck = 0
			end
		end
		local m = nil
		searchBlockmap('objects',function(mo,found)
			local dist = R_PointToAngle2(mo.x,mo.y,found.x,found.y)
			local angle = abs(dist-aim)
			if found != refmo and found.flags&searchflags and P_CheckSight(mo,found) and found.health and abs(angle) < fov/2*ANG1
				and (
					(teamcheck == nil or teamcheck == 0) or (teamcheck == 1 and team == found.ctfteam) or (teamcheck == -1 and team != found.ctfteam)
				)
				and (
					not(m and m.valid) 
					or (R_PointToDist2(mo.x,mo.y,m.x,m.y)+abs(mo.z-m.z) > R_PointToDist(mo.x,mo.y,found.x,found.y)+abs(mo.z-found.z))
				) then
				m = found
			end
		end,mo,mo.x-range,mo.x+range,mo.y-range,mo.y+range)
		return m
end

local function AutoAim(mo,aim,fov,teamcheck,ignorepain,projectile,speed,searchflags)
	local p = GetNearestPlayer(mo,fov,teamcheck,aim,ignorepain)
	if p then 
		local dist = FixedHypot(FixedHypot(p.mo.momx,p.mo.momy),p.mo.momz)
		local x1,y1,z1 = projectile.x,projectile.y,projectile.z
		local x2,y2,z2 = p.mo.x+p.mo.momx,p.mo.y+p.mo.momy,p.mo.z+p.mo.height/2+p.mo.momz
		local zang = GetZAngle(x1,y1,z1,x2,y2,z2)
		local xyang = R_PointToAngle2(x1,y1,x2,y2)
		InstaThrustZAim(projectile,xyang,zang,speed)
		return p.mo
	else
		local p = SearchObject(mo,aim,fov,mo.scale*640,searchflags,nil,teamcheck)
		if p then
			local x1,y1,z1 = projectile.x,projectile.y,projectile.z
			local x2,y2,z2 = p.x+p.momx,p.y+p.momy,p.z+p.momz
			local zang = GetZAngle(projectile.x,projectile.y,projectile.z,p.x,p.y,p.z+projectile.height/2)
			local xyang = R_PointToAngle2(x1,y1,x2,y2)
			InstaThrustZAim(projectile,xyang,zang,speed)
			return p
		end
	end
	return false
end

local function ERCThink(mo)
	if mo and mo.valid and mo.target and mo.target.valid and mo.target.target and mo.target.target.valid and mo.target.target.player and mo.target.target.player.eggstate != 0 then
		local dist = FRACUNIT*68
		local angle = -ANGLE_22h
		if mo.target.target.player.storeangle != nil then angle = $+mo.target.target.player.storeangle
		else angle = $+mo.target.angle
		end
		local x = mo.target.x+P_ReturnThrustX(nil,angle,dist)
		local y = mo.target.y+P_ReturnThrustY(nil,angle,dist)
		local z = mo.target.z+mo.target.scale*38
		P_TeleportMove(mo,x,y,z)
	else
		P_RemoveMobj(mo)
	end
end

local function ERLShift(mo)
	if mo.target and mo.target.valid and mo.target.player and mo.target.player.eggstate != 0 then
		local dist = FRACUNIT*76
		local angle = -ANGLE_22h
		if mo.target.player.storeangle != nil then angle = $+mo.target.player.storeangle
		else angle = $+mo.target.angle
		end
		local x = mo.target.x+P_ReturnThrustX(nil,angle,dist)
		local y = mo.target.y+P_ReturnThrustY(nil,angle,dist)
		local z = mo.target.z+mo.target.scale*48
		P_TeleportMove(mo,x,y,z)
	else
		P_RemoveMobj(mo)
	end
end

local function EggRobo(mo)
	if mo.player.playerstate != PST_LIVE or P_PlayerInPain(mo.player) or mo.player.pflags&PF_SPINNING or maptol&(TOL_NIGHTS|TOL_XMAS) or IsTagEggRobo(mo.player)
		then
		mo.player.eggtime = 0
		mo.player.eggstate = 0
		mo.player.eggcooldown = 0
	return end
	local canact =  not(mo.player.exiting or mo.player.powers[pw_nocontrol])
	//Player object control
-- 	mo.player.thrustfactor = 10
	local cmd = mo.player.cmd
	if mo.player.eggcmdlast == nil then
		mo.player.eggcmdlast = cmd.buttons
	end
	mo.player.pflags = $|PF_THOKKED
	if (mo.player.eggtime == nil) then
		mo.player.eggtime = 0
		mo.player.eggstate = 0
		mo.player.eggcooldown = 0
	end
	//Movement
	if canact and cmd.buttons&BT_JUMP and not(mo.player.eggcmdlast&BT_JUMP)
		S_StartSound(mo,sfx_s3ka0)
	end
	if (canact and cmd.buttons&BT_JUMP) or (P_MobjFlip(mo) == 1 and mo.z < mo.floorz+16*mo.scale) or (P_MobjFlip(mo) == -1 and mo.z+mo.height > mo.ceilingz-16*mo.scale) then
		local w = 1
		if mo.eflags&MFE_UNDERWATER then w = 2 end
		local amt = mo.scale/w*5
		mo.momz = max(min($+amt/4*P_MobjFlip(mo),max(amt,$)),min(-amt,$))
	end
	mo.player.eggtime = $+1
	//Start Attack
	if canact and cmd.buttons&BT_USE and not(mo.player.eggcmdlast&BT_USE) and not(mo.player.eggcooldown) and mo.player.eggstate == 0 then
		mo.player.eggstate = 1
		mo.player.eggtime = 0
	end
	//Attack Charging
	if mo.player.eggstate == 1 then
		if mo.player.eggtime >= 20 then
			mo.player.eggtime = 0
			mo.player.eggstate = 2
			S_StartSound(mo,sfx_s3k5e)
			mo.player.storeangle = mo.player.drawangle
		end
	end
	//Attack Firing
	if mo.player.eggstate == 2 then
		mo.player.pflags = $|PF_STASIS 
		mo.player.drawangle = mo.player.storeangle
		mo.momz = 0
		if not(mo.player.eggtime&1) then
			local e = P_SPMAngle(mo,MT_EGGROBOSHOT,mo.player.storeangle) 
			P_InstaThrust(mo,mo.player.storeangle+ANGLE_180,mo.scale*3)
			if e and e.valid then
-- 				e.scale = mo.scale*2
				ERLShift(e)
-- 				if mo.player.autoaim then
					AutoAim(mo,mo.player.storeangle,60,-1,true,e,mo.scale*36,MF_MONITOR|MF_BOSS|MF_ENEMY)
-- 				end
			end
		end
		if mo.player.eggtime >= 10 then
			mo.player.eggstate = 0
			mo.player.eggcooldown = 25
			mo.player.storeangle = nil
		end
	end
	mo.player.eggcooldown = max(0,$-1)
	mo.player.eggcmdlast = cmd.buttons
end

local function JetThink(mo)
	if not(mo and mo.valid) or mo.health == 0 or (mo.target and mo.target.valid and mo.target.target and mo.target.target.valid and mo.target.target.player and mo.target.target.player.playerstate == PST_DEAD) then
		P_RemoveMobj(mo)
	return end
	if not(mo.target and mo.target.target) then return end
	
	if mo.target.target.flags2&MF2_OBJECTFLIP then
		mo.flags2= $|MF2_OBJECTFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
	end
	mo.flags = $&~MF_NOGRAVITY
	mo.momz = 0
end

local function SpawnLimbs(mo)
	local limb
	//Gun
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOGIBLET1)
		P_InstaThrust(limb,mo.angle-ANGLE_45,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*7,false)
		limb.fuse = TICRATE
	end
	//Left Arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOGIBLET2)
		P_InstaThrust(limb,mo.angle-ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Right arm
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOGIBLET3)
		P_InstaThrust(limb,mo.angle+ANGLE_90,limb.scale*5)
		P_SetObjectMomZ(limb,FRACUNIT*5,false)
		limb.fuse = TICRATE
	end
	//Left leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOGIBLET4)
		P_InstaThrust(limb,mo.angle-ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
	//Right leg
	limb = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_EGGROBOGIBLET)
	if limb and limb.valid then
		limb.scale = mo.scale
		limb.flags2 = mo.flags2
		P_SetMobjStateNF(limb,S_EGGROBOGIBLET5)
		P_InstaThrust(limb,mo.angle+ANGLE_90,limb.scale*3)
		P_SetObjectMomZ(limb,FRACUNIT*3,false)
		limb.fuse = TICRATE
	end
end

local function EggRoboState(mo)
	if mo.player.playerstate == PST_DEAD then
		if mo.player.iseggrobo then
			mo.player.iseggrobo = false
			SpawnLimbs(mo)
		end
	return false end
	if mo.skin == "eggrobo" 
		if not(mo.player.iseggrobo) then
			mo.player.iseggrobo = true
			local dummy = P_SpawnMobj(mo.x,mo.y,mo.z,MT_EGGROBODUMMY)
			if dummy and dummy.valid then
				dummy.target = mo
				A_BossJetFume(dummy,4)
			end
		end
		return true
	else
		if mo.player.iseggrobo then
			mo.player.iseggrobo = false
		end
	return false end
end

local function EggRoboGiblet(mo)
	if mo.fuse&1 then
		mo.flags2 = $|MF2_DONTDRAW
	else
		mo.flags2 = $&~MF2_DONTDRAW
	end
end

local function EggRoboDummy(mo)
	if not (mo.target and mo.target.valid and mo.target.player and mo.target.player.iseggrobo) then
		P_RemoveMobj(mo)
	return end
	local eggrobo = mo.target
	P_TeleportMove(mo,eggrobo.x,eggrobo.y,eggrobo.z)
	mo.angle = eggrobo.player.drawangle
	if eggrobo.player.eggstate == 1 and eggrobo.player.eggtime == 0 then
		local e = P_SpawnMobj(mo.x,mo.y,mo.z,MT_EGGROBOCHARGE)
		e.target = mo
		e.scale = mo.scale/4
	end
	if eggrobo.flags2&MF2_OBJECTFLIP then
		mo.flags2= $|MF2_OBJECTFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
	end
	mo.flags = $&~MF_NOGRAVITY
	mo.momz = 0
end

addHook("MobjThinker",function(mo) EggRoboGiblet(mo) end,MT_EGGROBOGIBLET)
addHook("MobjThinker",function(mo) ERCThink(mo) end,MT_EGGROBOCHARGE)
addHook("MobjThinker",function(mo) JetThink(mo) end,MT_EGGROBO1JET)
addHook("MobjThinker",function(mo) EggRoboDummy(mo) end,MT_EGGROBODUMMY)
addHook("ThinkFrame",function()
	for player in players.iterate()
		if EggRoboState(player.mo) then
			EggRobo(player.mo)
		end
	end
end)
addHook("PlayerSpawn",function(player) player.iseggrobo = false end)